@echo off
echo.
echo                          FIX BATCH UTILITIES
echo Batch utilities are provided to extend the usefulness of the FIX program
echo by performing selected pre-specified editing functions on ASCII text files.
echo These also serve as models for the user's development of batch files or key
echo macros for his/her common editing tasks.  Summary of each utility:
echo.
echo   X2LINES   - Doubles spacing of each line of text.
echo   D2LINES   - Changes each double spaced line to a single spaced line.
echo   X2TABS    - Replaces each (horizontal) tab with 2 tabs.
echo   D2TABS    - Replaces each adjacent pair of tabs with a single tab.
echo   INDENT    - Inserts 1 tab at the beginning of each line (except 1st line).
echo   UPINDENT* - Adds 1 more indentation tab to the beginning of each line
echo               (except 1st line) that is already indented.
echo   DEINDENT* - Deletes 1 indentation tab from the beginning of each indented
echo               line (except 1st line).
echo   SPACE2*   - Reduces each contiguous sequence of spaces to 2 spaces
echo               (an iterative application which acts on feedback from FIX).
echo   SHIFTBRL* - Shifts braces ({),(}) in C source file(s) to the left 1 tab.
echo   SHIFTBRR* - Shifts braces ({),(}) in C source file(s) to the right 1 tab.
echo   GREPC*    - Counts strings, syntax/result similar to Unix "grep -c".
echo                                         [*] With Registered or Licensed FIX.
echo The common command line syntax for these utilities (except for grepc) is:
echo        UTILNAME [d:][path]FILENAME  [d:][path][outfile]
echo For utility-specific help, enter the utility name with no arguments.
